"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_unstyled_button_1 = require("@snowcoders/react-unstyled-button");
var classnames = require("classnames");
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs(props) {
        var _this = _super.call(this, props) || this;
        _this.validateOldProps();
        _this.state = {
            selectedTabIndex: _this.props.defaultTabIndex || _this.props.tabIndex || 0
        };
        return _this;
    }
    Tabs.prototype.componentDidUpdate = function (oldProps) {
        this.validateOldProps(oldProps);
    };
    Tabs.prototype.render = function () {
        var _this = this;
        var _a = this.props, isBaseStylesDisabled = _a.isBaseStylesDisabled, className = _a.className;
        className = classnames({ "sci-react-tabs": isBaseStylesDisabled !== true }, className);
        return (React.createElement("div", { className: className },
            this.renderTabs(),
            React.createElement("div", { className: "contents" }, this.props.tabs.map(function (value, index) {
                var className = classnames("content", { "visible": index === _this.state.selectedTabIndex });
                return (React.createElement("div", { className: className }, value.content));
            }))));
    };
    Tabs.prototype.renderTabs = function () {
        var tabs = [];
        for (var tabIndex = 0; tabIndex < this.props.tabs.length; tabIndex++) {
            var tab = this.props.tabs[tabIndex];
            var className = classnames("tab-item", { "selected": tabIndex === this.state.selectedTabIndex });
            tabs.push(React.createElement("li", { className: className, key: tabIndex },
                React.createElement(react_unstyled_button_1.UnstyledButton, { className: "tab-button", onClick: this.getOnTabClick(tabIndex) }, tab.header)));
        }
        return (React.createElement("ul", { className: "tabs" }, tabs));
    };
    Tabs.prototype.getOnTabClick = function (tabIndex) {
        var _this = this;
        return function () {
            var propCallback = function () {
                if (_this.props.onTabChange != null) {
                    _this.props.onTabChange(tabIndex);
                }
            };
            if (_this.props.tabIndex == null) {
                // Uncontrolled components maintain their own state
                _this.setState({
                    selectedTabIndex: tabIndex
                }, function () {
                    propCallback();
                });
            }
            else {
                // Controlled components have their state maintained
                propCallback();
            }
        };
    };
    Tabs.prototype.validateOldProps = function (oldProps) {
        if (this.props.defaultTabIndex != null &&
            this.props.tabIndex != null) {
            throw new Error("@snowcoders/react-tabs - component can either be controled (props.tabIndex) or uncontroled (props.defaultTabIndex) but not both");
        }
        if (oldProps != null) {
            if (oldProps.defaultTabIndex != null && this.props.defaultTabIndex == null ||
                oldProps.tabIndex != null && this.props.tabIndex == null) {
                throw new Error("@snowcoders/react-tabs - component cannot switch between uncontrolled and controlled component after mounting");
            }
        }
    };
    return Tabs;
}(React.Component));
exports.Tabs = Tabs;
//# sourceMappingURL=component.js.map